<!DOCTYPE html>
<html>

<head>
  <meta charset='utf-8'>
  <title>Pizza 365 project</title>
  <meta name='viewport' content='width=device-width, initial-scale=1'>
  <link rel="stylesheet" href="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/css/bootstrap.min.css">
  <script src="https://cdnjs.cloudflare.com/ajax/libs/jquery/3.6.0/jquery.min.js"></script>
  <script src="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/js/bootstrap.min.js"></script>
</head>

<body onload="onPageLoad()">
  <div class="container">
    <p class="h3 text-center mt-5"> Chọn đồ uống </p>
    <div class="form-group col-12">
      <hr class="mt-5 mb-5" />
    </div>

    <div class="form-group">
      <label>Đồ uống:</label>
      <select id="select-drink" class="form-control">
        <option>Chọn đồ uống</option>
      </select>
    </div>
    <button id="show-result" class="btn btn-primary w-25" onclick="onDisplayClick()">Hiển thị</button>
  </div>
  <script>
    "use strict";
    /*** REGION 1 - Global variables - Vùng khai báo biến, hằng số, tham số TOÀN CỤC */
    const gREQUEST_STATUS_OK = 200;
    const gREQUEST_READY_STATUS_FINISH_AND_OK = 4;
    const gBASE_URL = "http://203.171.20.210:8080/devcamp-pizza365/drinks";

    /*** REGION 2 - Vùng gán / thực thi sự kiện cho các elements */
    /*** REGION 3 - Event handlers - Vùng khai báo các hàm xử lý sự kiện */
    
    //call API in the event of the page's loading
    function onPageLoad(){
      
      //call API to get data from server
      var vXmlHttp = new XMLHttpRequest();
          vXmlHttp.open("GET", gBASE_URL, true);
          vXmlHttp.send();
          vXmlHttp.onreadystatechange = function(){
            if (this.readyState == gREQUEST_READY_STATUS_FINISH_AND_OK && this.status == gREQUEST_STATUS_OK){
              console.log("%cResponseText: ", "color: orange", this.responseText);
              loadJsonSelect(vXmlHttp.responseText);
            }
          }
    }

      //loading JSON data to the select element
      function loadJsonSelect(paramData){
        "use strict";
        debugger;
        var vJsonParsing = JSON.parse(paramData);
        console.log("%cJson Parsing: ", "color: green", vJsonParsing);
        var vSelectElement = document.getElementById("select-drink");
            for (var i = 0; i < vJsonParsing.length; i++){
              var vDrinkOption = document.createElement("option");
                  vDrinkOption.value = vJsonParsing[i].maNuocUong;
                  vDrinkOption.text = vJsonParsing[i].tenNuocUong;
              vSelectElement.appendChild(vDrinkOption);
              //console.log(vSelectElement);
            }    
      }

    //add function to the button "Hiển Thị"
    function onDisplayClick(){
    
        //create drink object
        var vDrinkObject = {
            maNuocUong: "",
            tenNuocUong: ""
        };

        //read data from the web form
        readDataWebForm(vDrinkObject);

        //display to console
        displayConsole(vDrinkObject);

      }

        //read data from the web form
        function readDataWebForm(paramData){
          
          var vSelectedDrink = document.getElementById("select-drink");
              paramData.tenNuocUong = vSelectedDrink.options[vSelectedDrink.selectedIndex].text;
              //console.log(paramData.tenNuocUong);
        }

        //to show the selected drink to console
        function displayConsole(paramData){
        
        console.log("%cTHE DRINK IS SELECTED: ", "color: orange", paramData.tenNuocUong)
      }

    
    /*** REGION 4 - Common funtions - Vùng khai báo hàm dùng chung trong toàn bộ chương trình*/
    
  </script>
</body>

</html>